app ( Image mos ) mAdd( Image imgs[], Table img_tbl, MosaicData hdr )
{
    mAdd "-p" @dirname( imgs[0] ) "-n" @img_tbl @hdr @mos;
}


app ( Image bg_img ) mBackground( Image img, float a, float b, float c )
{
    mBackground "-n" @img @bg_img a b c;
}


app ( Table corr_tbl ) mBgModel( Table img_tbl, Table fits_tbl )
{
    mBgModel @img_tbl @fits_tbl @corr_tbl;
}


app ( Table fits_tbl ) mConcatFit( Table status_tbl, Status stats[] )
{
    mConcatFit @status_tbl @fits_tbl @dirname( stats[0] );
}


app ( Image diff_img ) mDiff( Image proj_img_1, Image proj_img_2, MosaicData hdr )
{
//    mDiff "-n" @proj_img_1 @proj_img_2 @diff_img @hdr;
    mDiff_wrap "-n" @proj_img_1 @proj_img_2 @diff_img @hdr;
}


app ( Status stat ) mFitplane( Image diff_img )
{
//    mFitplane "-s" @stat @diff_img;
    mFitplane_wrap "-s" @stat @diff_img;
}


app ( Table img_tbl ) mImgtbl( Image imgs[] )
{
    mImgtbl @dirname( imgs[0] ) @img_tbl;
}


app ( MosaicData hdr ) mMakeHdr( Table img_tbl )
{
    mMakeHdr @img_tbl @hdr;
}


app ( JPEG mos_img_jpg ) mJPEG( Image mos_img )
{
    mJPEG "-gray" @mos_img "20%" "99.98%" "loglog" "-out" @mos_img_jpg;
}


app ( Table diff_tbl ) mOverlaps( Table img_tbl )
{
    mOverlaps @img_tbl @diff_tbl;
}


app ( Image proj_img ) mProjectPP( Image raw_img, MosaicData hdr )
{
    mProjectPP "-X" @raw_img @proj_img @hdr;
}


app ( Image proj_img ) mProject( Image raw_img, MosaicData hdr )
{
    mProject "-X" @raw_img @proj_img @hdr;
}



/*----------------------------------------------------------------------------------*/
/*                                                                                  */
/*                                Util Scripts                                      */
/*                                                                                  */
/*----------------------------------------------------------------------------------*/

app ( Table back_tbl ) Background_list( Table imgs_tbl, Table corrs_tbl )
{
    Background_list @imgs_tbl @corrs_tbl @back_tbl;
}


app ( Table stat_tbl ) create_status_table( Table diff_tbl )
{
    create_status_table @diff_tbl @stat_tbl;
}
